Index: loader/source/main.c
===================================================================
--- loader/source/main.c	(revision 542)
+++ loader/source/main.c	(working copy)
@@ -888,54 +1276,204 @@
 			{
 				case -1:
 					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "No Controller plugged in! %25s", " ");
-					break;
+					break;	
 				case -2:
 					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Missing %s:/controller.ini %20s", GetRootDevice(), " ");
-					break;
+					break;	
 				case -3:
 					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Controller does not match %s:/controller.ini %6s", GetRootDevice(), " ");
-					break;
+					break;	
 				case -4:
 					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Invalid Polltype in %s:/controller.ini %12s", GetRootDevice(), " ");
-					break;
+					break;	
 				case -5:
 					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Invalid DPAD value in %s:/controller.ini %9s", GetRootDevice(), " ");
-					break;
+					break;	
 				case -6:
 					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "PS3 controller init error %25s", " ");
-					break;
+					break;	
 				case -7:
 					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Gamecube adapter for Wii u init error %13s", " ");
-					break;
+					break;	
 				default:
 					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Unknown error %d %35s", STATUS_ERROR, " ");
-					break;
+					break;	
 			}
-		}*/
+		}
+        if(STATUS_LOADING == 9)
+            PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 410*1, MENU_POS_Y + 20*19, "\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83");
+        if(STATUS_LOADING > 9 && STATUS_LOADING < 20)
+            PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430*1, MENU_POS_Y + 20*19, "\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83");
+        if(STATUS_LOADING == 10)
+            PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 450*1, MENU_POS_Y + 20*19, "\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83");
+        if(STATUS_LOADING > 10 && STATUS_LOADING < 20)
+            PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 470*1, MENU_POS_Y + 20*19, "\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83");
+        GRRLIB_Screen2Texture(0, 0, screen_buffer, GX_FALSE); // Copy all status messages
+        GRRLIB_Render();
+        ClearScreen();
+        PrintInfo();
+    }
+ 
+    //gprintf("Nintendont at your service!\r\n");
+ 
+    GRRLIB_DrawImg(0, 0, screen_buffer, 0, 1, 1, 0xFFFFFFFF); // Draw all status messages
+            PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 490*1, MENU_POS_Y + 20*19, "\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83\xe2\x95\x83");
+    GRRLIB_Render();
+}	
+	
+ //white no loading bar
+	else if ((which_bg == BG_NOBAR) || (which_bg == BG_BLACK))
+	{     while(1)
+    {
+    	DCInvalidateRange( STATUS, 0x20 );
+		if( STATUS_LOADING == 0xdeadbeef )
+		break;
+		
+		if(STATUS_LOADING == -2)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*8, "Init USB/SD device... Error! %d  Shutting down", STATUS_ERROR);
+         if(STATUS_LOADING == -3)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*9, "Mounting USB/SD device... Error! %d  Shutting down", STATUS_ERROR);
+ 		if(STATUS_LOADING == 5) 
+			{ PrintFormat(DEFAULT_SIZE, (STATUS_ERROR == -7) ? MAROON:WHITE, MENU_POS_X + 230*1, MENU_POS_Y + 20*19, (STATUS_ERROR == -7) ? "Checking FS... Timeout!" : " ");}
+		if(STATUS_LOADING == -5)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*10, "Checking FS... Error! %d Shutting down", STATUS_ERROR);
+		if(STATUS_LOADING == -6)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*12, "ES_LoadModules... Error! %d Shutting down", STATUS_ERROR);
+        if(STATUS_LOADING == 8)
+        {
+            PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 370*1, MENU_POS_Y + 20*19, " ");
+			hid_count++;
+			if ( (STATUS_ERROR) == 1 && (hid_count > 15))
+			{
+				PrintFormat(DEFAULT_SIZE, 0xFFD70000, MENU_POS_X, MENU_POS_Y + 17*24, "          Make sure the Controller is plugged in");
+			}			else
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*15, "%50s", " ");	
+		}
+		if(STATUS_LOADING == -8)
+		{
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*14, "Init HID devices... Failed! Shutting down");
+			switch (STATUS_ERROR)
+			{
+				case -1:
+					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "No Controller plugged in! %25s", " ");
+					break;	
+				case -2:
+					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Missing %s:/controller.ini %20s", GetRootDevice(), " ");
+					break;	
+				case -3:
+					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Controller does not match %s:/controller.ini %6s", GetRootDevice(), " ");
+					break;	
+				case -4:
+					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Invalid Polltype in %s:/controller.ini %12s", GetRootDevice(), " ");
+					break;	
+				case -5:
+					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Invalid DPAD value in %s:/controller.ini %9s", GetRootDevice(), " ");
+					break;	
+				case -6:
+					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "PS3 controller init error %25s", " ");
+					break;	
+				case -7:
+					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Gamecube adapter for Wii u init error %13s", " ");
+					break;	
+				default:
+					PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*15, "Unknown error %d %35s", STATUS_ERROR, " ");
+					break;	
+			}
+		}
+        GRRLIB_Screen2Texture(0, 0, screen_buffer, GX_FALSE); // Copy all status messages
+        GRRLIB_Render();
+        ClearScreen();
+        PrintInfo();
+    }
+ 
+    //gprintf("Nintendont at your service!\r\n");
+ 
+    GRRLIB_DrawImg(0, 0, screen_buffer, 0, 1, 1, 0xFFFFFFFF); // Draw all status messages
+    GRRLIB_Render();
+}	
+	
+	//Dark Background & White text
+    else if (which_bg == BG_LEGACY)
+    {
+	while(1)
+	{
+		DCInvalidateRange( STATUS, 0x20 );
+		if( STATUS_LOADING == 0xdeadbeef )
+			break;
+		
+		PrintInfo();
+		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*6, "Loading patched kernel... %d", STATUS_LOADING);
+		if(STATUS_LOADING == 0)
+		{
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*7, "ES_Init...");
+		// Cleans the -1 when it's past it to avoid confusion if another error happens. e.g. before it showed "81" instead of "8" if the controller was unplugged.
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 163, MENU_POS_Y + 20*6, " ");
+		}
+		if((STATUS_LOADING > 0 || abs(STATUS_LOADING) > 1) && STATUS_LOADING < 20)
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*7, "ES_Init... Done!");
+		if(STATUS_LOADING == 2)
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*8, "Initing storage devices...");
+		if(abs(STATUS_LOADING) > 2 && abs(STATUS_LOADING) < 20)
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*8, "Initing storage devices... Done!");
+		if(STATUS_LOADING == -2)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*8, "Initing storage devices... Error! %d  Shutting down", STATUS_ERROR);
+		if(STATUS_LOADING == 3)
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*9, "Mounting USB/SD device...");
+		if(abs(STATUS_LOADING) > 3 && abs(STATUS_LOADING) < 20)
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*9, "Mounting USB/SD device... Done!");
+		if(STATUS_LOADING == -3)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*9, "Mounting USB/SD device... Error! %d  Shutting down", STATUS_ERROR);
+		if(STATUS_LOADING == 5) {
+			PrintFormat(DEFAULT_SIZE, (STATUS_ERROR == -7) ? MAROON:WHITE, MENU_POS_X, MENU_POS_Y + 20*10, (STATUS_ERROR == -7) ? "Checking FS... Timeout!" : "Checking FS...");
+		}
+		if(abs(STATUS_LOADING) > 5 && abs(STATUS_LOADING) < 20)
+		{
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*10, "Checking FS... Done!");
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*11, "Drive size: %.02f%s Sector size: %d", STATUS_DRIVE, STATUS_GB_MB ? "GB" : "MB", STATUS_SECTOR);
+		}
+		if(STATUS_LOADING == -5)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*10, "Checking FS... Error! %d Shutting down", STATUS_ERROR);
+		if(STATUS_LOADING == 6)
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*12, "ES_LoadModules...");
+		if(abs(STATUS_LOADING) > 6 && abs(STATUS_LOADING) < 20)
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*12, "ES_LoadModules... Done!");
+		if(STATUS_LOADING == -6)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*12, "ES_LoadModules... Error! %d Shutting down", STATUS_ERROR);
+		if(STATUS_LOADING == 7)
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*13, "Loading config...");
+		if(abs(STATUS_LOADING) > 7 && abs(STATUS_LOADING) < 20)
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*13, "Loading config... Done!");
 		if(STATUS_LOADING == 9)
-			PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*14, "Init DI... %40s", " ");
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*14, "Init DI... %40s", " ");
 		if(abs(STATUS_LOADING) > 9 && abs(STATUS_LOADING) < 20)
-			PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*14, "Init DI... Done! %35s", " ");
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*14, "Init DI... Done! %35s", " ");
 		if(STATUS_LOADING == 10)
-			PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*15, "Init CARD...");
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*15, "Init CARD...");
 		if(abs(STATUS_LOADING) > 10 && abs(STATUS_LOADING) < 20)
-			PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*15, "Init CARD... Done!");
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*15, "Init CARD... Done!");
 		GRRLIB_Screen2Texture(0, 0, screen_buffer, GX_FALSE); // Copy all status messages
 		GRRLIB_Render();
 		ClearScreen();
-		while((STATUS_LOADING < -1) && (STATUS_LOADING > -20)) //displaying a fatal error
-				; //do nothing wait for shutdown
+		while ((STATUS_LOADING < -1) && (STATUS_LOADING > -20))	//displaying a fatal error
+			{ }	//do nothing wait for shutdown
 	}
+
+	gprintf("Nintendont at your service!\r\n");
+
 	DrawBuffer(); // Draw all status messages
-	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*17, "Nintendont kernel looping, loading game...");
+	PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*16, "Nintendont kernel looping, loading game...");
 	GRRLIB_Render();
 	DrawBuffer(); // Draw all status messages
-//	memcpy( (void*)0x80000000, (void*)0x90140000, 0x1200000 );
+}	
+
+	else{}
+
 	GRRLIB_FreeTexture(background);
 	GRRLIB_FreeTexture(screen_buffer);
 	GRRLIB_FreeTTF(myFont);
 	GRRLIB_Exit();
-
+	
 	gprintf("GameRegion:");
 
 	u32 vidForce = (ncfg->VideoMode & NIN_VID_FORCE);
@@ -958,6 +1496,7 @@
 		case 'X':
 		case 'Y':
 		case 'Z':
+
 			if(progressive || (vidForce && (vidForceMode == NIN_VID_FORCE_PAL60 ||
 				vidForceMode == NIN_VID_FORCE_MPAL || vidForceMode == NIN_VID_FORCE_NTSC)))
 				*(vu32*)0x800000CC = 5;
@@ -993,8 +1532,8 @@
 	{
 		switch(vidForceMode)
 		{
-			case NIN_VID_FORCE_PAL50:
-				vmode = &TVPal528IntDf;
+		case NIN_VID_FORCE_PAL50:
+			vmode = &TVPal528IntDf;
 				break;
 			case NIN_VID_FORCE_PAL60:
 				vmode = &TVEurgb60Hz480IntDf;
@@ -1008,8 +1547,11 @@
 				break;
 		}
 	}
+	
 	if((ncfg->Config & NIN_CFG_MEMCARDEMU) == 0) //setup real sram video
 	{
+		// Using real memory card slots. (Wii only)
+		// Setup real SRAM language.		
 		syssram *sram;
 		sram = __SYS_LockSram();
 		sram->display_offsetH = 0;	// Clear Offset
@@ -1043,7 +1585,7 @@
 		VIDEO_WaitVSync();
 	else while(VIDEO_GetNextField())
 		VIDEO_WaitVSync();
-
+	
 	*(u16*)(0xCC00501A) = 156;	// DSP refresh rate
 	/* from libogc, get all gc pads to work */
 	u32 buf[2];
@@ -1088,30 +1630,30 @@
 	//0x9300300C is already used for multi-iso
 	memset((void*)0x93003010, 0, 0x10); //disable rumble on bootup
 	DCFlushRange((void*)0x93003000, 0x20);
-
-	//lets prevent weird events
-	__STM_Close();
-
-	//THIS thing right here, it interrupts some games and breaks them
-	//To fix that, call ExecSuspendScheduler so WC24 just sleeps
-	u32 out = 0;
-	fd = IOS_Open("/dev/net/kd/request", 0);
-	IOS_Ioctl(fd, IOCTL_ExecSuspendScheduler, NULL, 0, &out, 4);
-	IOS_Close(fd);
-
+	
+ 	//lets prevent weird events
+ 	__STM_Close();
+ 	
+ 	//THIS thing right here, it interrupts some games and breaks them
+ 	//To fix that, call ExecSuspendScheduler so WC24 just sleeps
+ 	u32 out = 0;
+ 	fd = IOS_Open("/dev/net/kd/request", 0);
+ 	IOS_Ioctl(fd, IOCTL_ExecSuspendScheduler, NULL, 0, &out, 4);
+ 	IOS_Close(fd);
+ 	
 	write16(0xD8B420A, 0); //disable MEMPROT again after reload
 	//u32 level = IRQ_Disable();
 	__exception_closeall();
 	__lwp_thread_closeall();
 
-	DVDStartCache(); //waits for kernel start
+ 	DVDStartCache(); //waits for kernel start
 	DCInvalidateRange((void*)0x90000000, 0x1000000);
 	memset((void*)(void*)0x90000000, 0, 0x1000000); //clear ARAM
 	DCFlushRange((void*)0x90000000, 0x1000000);
 
 	gprintf("Game Start\n");
-
-	if(useipl)
+	
+	if((useipl) && (memcmp(&(ncfg->GameID), "RELS", 4) != 0) && (memcmp(&(ncfg->GameID), "D4", 2) != 0)) //&& (ncfg->Config & NIN_CFG_MEMCARDEMU)
 	{
 		load_ipl(iplbuf);
 		*(vu32*)0xD3003420 = 0x5DEA;
@@ -1144,6 +1686,6 @@
 		"blr\n"
 	);
 	//IRQ_Restore(level);
-
 	return 0;
 }
+
